


// compares tow items.  need this since we want to compare elements of arrays
//  since the interface doesn't have a way to pass col number, we do it with a variable

var sort_col=0;
function colcompare(a,b) {
  if (a[sort_col]<b[sort_col])
	return -1;
  if (a[sort_col]>b[sort_col])
	return 1;
  return 0;
}

//  extracted this list from NOAAs pages.  made some mods to make it a bit
// better.  For example, made Baltimore and Washington two entries.
// Only use the second element which is station ID
// and 4th element which is name of location  

var radar_sites=new Array(
	["ABERDEEN","KABR","ABERDEEN, SD","ABERDEEN, SD"],
	["BISMARCK","KBIS","BISMARCK, ND","BISMARCK, ND"],
	["CHEYENNE","KCYS","CHEYENNE, WY","CHEYENNE, WY"],
	["CHICAGO","KLOT","ROMEOVILLE, IL","CHICAGO, IL"],
	["DENVER","KFTG","FRONT RANGE AP, CO","DENVER/BOULDER, CO"],
	["DES MOINES","KDMX","JOHNSTON, IA","DES MOINES, IA"],
	["DETROIT","KDTX","WHITE LAKE, MI","DETROIT, MI"],
	["DODGE CITY","KDDC","DODGE CITY, KS","DODGE CITY, KS"],
	["DULUTH","KDLH","DULUTH, MN","DULUTH, MN"],
	["FARGO/GRAND FORKS","KMVX","GRAND FORKS, ND","FARGO/GRAND FORKS, ND"],
	["GOODLAND","KGLD","GOODLAND, KS","GOODLAND, KS"],
	["GRAND ISLAND","KUEX","BLUE HILL, NE","HASTINGS, NE"],
	["GRAND JUNCTION","KGJX","GRAND JUNCTION, CO","GRAND JUNCTION, CO"],
	["GRAND RAPIDS","KGRR","GRAND RAPIDS, MI","GRAND RAPIDS, MI"],
	["GREEN BAY","KGRB","GREEN BAY, WI","GREEN BAY, WI"],
	["INDIANAPOLIS","KIND","INDIANAPOLIS, IN","INDIANAPOLIS, IN"],
	["JACKSON, KY","KJKL","JACKSON, KY","JACKSON, KY"],
	["LA CROSSE","KARX","LA CROSSE, WI","LA CROSSE, WI"],
	["LINCOLN","KILX","LINCOLN, IL","LINCOLN/CENTRAL ILLINOIS, IL"],
	["LOUISVILLE","KLVX","FORT KNOX, KY","LOUISVILLE, KY"],
	["MARQUETTE","KMQT","NEGAUNEE, MI","MARQUETTE, WI"],
	["MILWAUKEE","KMKX","DOUSMAN, WI","MILWAUKEE, WI"],
	["MINNEAPOLIS","KMPX","CHANHASSEN, MN","MINNEAPOLIS, MN"],
	["NCL MICHIGAN","KAPX","GAYLORD, MI","GAYLORD/ALPENA, MI"],
	["NORTH PLATTE","KLNX","NORTH PLATTE, NE","NORTH PLATTE, NE"],
	["NORTHERN INDIANA","KIWX","NORTH WEBSTER, IN","N. WEBSTER/NORTHERN, IN"],
	["OMAHA","KOAX","VALLEY, NE","OMAHA, NE"],
	["PADUCAH","KPAH","PADUCAH, KY","PADUCAH, KY"],
	["PLEASANT HILL","KEAX","PLEASANT HILL, MO","PLEASANT HILL, MO"],
	["PUEBLO","KPUX","PUEBLO, CO","PUEBLO, CO"],
	["QUAD CITIES","KDVN","DAVENPORT, IA","QUAD CITIES, IA"],
	["RAPID CITY","KUDX","NEW UNDERWOOD, SD","RAPID CITY, SD"],
	["RIVERTON/LANDER","KRIW","RIVERTON, WY","RIVERTON, WY"],
	["SIOUX FALLS","KFSD","SIOUX FALLS, SD","SIOUX FALLS, IA"],
	["SPRINGFIELD","KSGF","SPRINGFIELD, MO","SPRINGFIELD, MO"],
	["ST LOUIS","KLSX","WELDON SPRING, MO","ST. LOUIS, MO"],
	["TOPEKA","KTWX","TOPEKA, KS","TOPEKA, KS"],
	["WICHITA","KICT","WICHITA, KS","WICHITA, KS"],
	["ALBANY","KENX","EAST BERNE, NY","ALBANY, NY"],
	["BINGHAMTON","KBGM","BINGHAMTON, NY","BINGHAMTON, NY"],
	["BOSTON","KBOX","TAUNTON, MA","BOSTON /TAUNTON, MA"],
	["BROOKHAVEN","KOKX","UPTON, NY","NEW YORK CITY, NY"],
	["BUFFALO","KBUF","BUFFALO, NY","BUFFALO, NY"],
	["BURLINGTON","KCXX","COLCHESTER, VT","BURLINGTON, VT"],
	["CARIBOU","KCBW","HOULTON, ME","CARIBOU, ME"],
	["CHARLESTON, SC","KCLX","GRAYS, SC","CHARLESTON, SC"],
	["CHARLESTON, WV","KRLX","CHARLESTON, WV","CHARLESTON, WV"],
	["CINCINNATI","KILN","WILMINGTON, OH","CINCINNATI, OH"],
	["CLEVELAND","KCLE","CLEVELAND, OH","CLEVELAND, OH"],
	["COLUMBIA","KCAE","WEST COLUMBIA, SC","COLUMBIA, SC"],
	["GREENVILLE","KGSP","GREER, SC","GREENVILLE/SPRTBG, SC"],
	["MOREHEAD CITY","KMHX","NEWPORT, NC","MOREHEAD CITY, NC"],
	["NORFOLK","KAKQ","WAKEFIELD, VA","WAKEFIELD, VA"],
	["PHILADELPHIA","KDIX","FORT DIX, NJ","PHILADELPHIA, PA"],
	["PITTSBURGH","KPBZ","CORAOPOLIS, PA","PITTSBURGH, PA"],
	["PORTLAND, ME","KGYX","GRAY, ME","PORTLAND, ME"],
	["RALEIGH/DURHAM","KRAX","CLAYTON, NC","RALEIGH/DURHAM, NC"],
	["ROANOKE","KFCX","ROANOKE, VA","ROANOKE, VA"],
	["STATE COLLEGE","KCCX","STATE COLLEGE, PA","STATE COLLEGE/CENTRAL, PA"],
	["STERLING","KLWX","STERLING, VA","STERLING, VA"],
	["WASHINGTON","KLWX","WASHINGTON, D.C","WASHINGTON, D.C"],
	["BALTIMORE","KLWX","BALTIMORE, MD","BALTIMORE, MD"],
	["WILMINGTON","KLTX","SHALLOTTE, NC","WILMINGTON, NC"],
	["ALBUQUERQUE","KABX","ALBUQUERQUE, NM","ALBUQUERQUE, NM"],
	["AMARILLO","KAMA","AMARILLO, TX","AMARILLO, TX"],
	["ATLANTA","KFFC","PEACHTREE CITY, GA","ATLANTA, GA"],
	["SAN ANTONIO","KEWX","NEW BRAUNFELS, TX","SANANTONIO, TX"],
	["AUSTIN","KEWX","NEW BRAUNFELS, TX","AUSTIN, TX"],
	["BIRMINGHAM","KBMX","ALABASTER, AL","BIRMINGHAM, AL"],
	["BROWNSVILLE","KBRO","BROWNSVILLE, TX","BROWNSVILLE, TX"],
	["CORPUS CHRISTI","KCRP","CORPUS CHRISTI, TX","CORPUS CHRISTI, TX"],
	["DALLAS/FT WORTH","KFWS","FORT WORTH, TX","DALLAS / FT. WORTH, TX"],
	["EL PASO","KEPZ","SANTA TERESA, NM","EL PASO, TX"],
	["HOUSTON","KHGX","DICKINSON, TX","HOUSTON/ GALVESTON, TX"],
	["JACKSON/BRANDON, MS","KDGX","BRANDON, MS","JACKSON, MS"],
	["JACKSONVILLE","KJAX","JACKSONVILLE, FL","JACKSONVILLE, FL"],
	["KEY WEST","KBYX","BOCA CHICA KEY, FL","KEY WEST, FL"],
	["KNOXVILLE","KMRX","MORRISTOWN, TN","KNOXVILLE, TN"],
	["LAKE CHARLES","KLCH","LAKE CHARLES, LA","LAKE CHARLES, LA"],
	["LITTLE ROCK","KLZK","NORTH LITTLE ROCK, AR","LITTLE ROCK, AR"],
	["LUBBOCK","KLBB","LUBBOCK, TX","LUBBOCK, TX"],
	["MELBOURNE","KMLB","MELBOURNE, FL","MELBOURNE, FL"],
	["MEMPHIS","KNQA","MILLINGTON, TN","MEMPHIS, TN"],
	["MIAMI","KAMX","MIAMI, FL","MIAMI, FL"],
	["MIDLAND/ODESSA","KMAF","MIDLAND, TX","MIDLAND/ODESSA, TX"],
	["MOBILE","KMOB","MOBILE, AL","MOBILE, AL"],
	["NASHVILLE","KOHX","OLD HICKORY, TN","NASHVILLE, TN"],
	["NORMAN","KTLX","MIDWEST CITY, OK","NORMAN, OK"],
	["NORTHEAST ALABAMA","KHTX","HYTOP, AL","HUNTSVILLE, AL"],
	["SAN ANGELO","KSJT","SAN ANGELO, TX","SAN ANGELO, TX"],
	["SHREVEPORT","KSHV","SHREVEPORT, LA","SHREVEPORT, LA"],
	["SLIDELL","KLIX","SLIDELL, LA","NEW ORLEANS/SLIDELL, LA"],
	["TALLAHASSEE","KTLH","TALLAHASSEE, FL","TALLAHASSEE, FL"],
	["TAMPA","KTBW","RUSKIN, FL","TAMPA BAY AREA, FL"],
	["TULSA","KINX","INOLA, OK","TULSA, OK"],
	["WESTERN ARKANSAS","KSRX","CHAFFEE RIDGE, AR","FAYETTEVILLE/FORT SMITH, AR"],
	["BILLINGS","KBLX","BILLINGS, MT","BILLINGS, MT"],
	["BOISE","KCBX","BOISE, ID","BOISE, ID"],
	["CEDAR CITY","KICX","CEDAR CITY, UT","CEDAR CITY, UT"],
	["ELKO","KLRX","ELKO, NV","ELKO, NV"],
	["EUREKA (BUNKER HILL)","KBHX","EUREKA, CA","EUREKA, CA"],
	["FLAGSTAFF","KFSX","FLAGSTAFF, AZ","FLAGSTAFF, AZ"],
	["GLASGOW","KGGW","GLASGOW, MT","GLASGOW, MT"],
	["GREAT FALLS","KTFX","GREAT FALLS, MT","GREAT FALLS, MT"],
	["LAS VEGAS","KESX","LAS VEGAS, NV","LAS VEGAS, NV"],
	["LOS ANGELES","KVTX","LOS ANGELES, CA","LOS ANGELES, CA"],
	["MEDFORD","KMAX","MEDFORD, OR","MEDFORD, OR"],
	["MISSOULA","KMSX","MISSOULA, MT","MISSOULA, MT"],
	["PENDLETON","KPDT","PENDLETON, OR","PENDLETON, OR"],
	["PHOENIX","KIWA","PHOENIX, AZ","PHOENIX, AZ"],
	["POCATELLO","KSFX","SPRINGFIELD, ID","POCATELLO, ID"],
	["PORTLAND, OR","KRTX","PORTLAND, OR","PORTLAND, OR"],
	["RENO","KRGX","NIXON, NV","RENO, NV"],
	["SACRAMENTO","KDAX","DAVIS, CA","SACRAMENTO, CA"],
	["SALT LAKE CITY","KMTX","SALT LAKE CITY, UT","SALT LAKE CITY, UT"],
	["SAN DIEGO","KNKX","SAN DIEGO, CA","SAN DIEGO, CA"],
	["MONTEREY","KMUX","LOS GATOS, CA","MONTEREY, CA"],
	["SAN FRANCISCO","KMUX","LOS GATOS, CA","SAN FRANCISCO, CA"],
	["SAN JOAQUIN VALY","KHNX","HANFORD, CA","SAN JOAQUIN/HANFORD, CA"],
	["SANTA ANA MTS","KSOX","SANTA ANA MOUNTAINS, CA","SANTA ANNA MTS, CA"],
	["SEATTLE","KATX","EVERETT, WA","SEATTLE / TACOMA, WA"],
	["SPOKANE","KOTX","SPOKANE, WA","SPOKANE, WA"],
	["TUCSON","KEMX","TUCSON, AZ","TUCSON, AZ"],
	["YUMA","KYUX","YUMA, AZ","YAMA, AZ"],
	["SAN JUAN", "TJUA","SAN JUAN, PR", "SAN JUAN, PR"] 
);
// set the global so the sortfn knows what col to use



// if first time, different behavior
var first_time = true;

// does the popup to ask for weather site
function set_radar_sites(){
	print(preferences["WeatherStation"].value);
	if(!first_time ||  typeof(preferences["WeatherStation"].value) == "undefined" 				|| preferences["WeatherStation"].value == null 
		|| preferences["WeatherStation"].value == "" ){
		
		sort_col=3;
		// sort the array
		radar_sites.sort(colcompare);
		var ffield = new Array();
		ffield[0] = new FormField();
		ffield[0].name="radar_site";
		ffield[0].type='popup';
		ffield[0].title = " Radar Site: ";
		ffield[0].option = new Array();
		ffield[0].optionValue = new Array();
		
		var cnt = radar_sites.length;
		var loop =0;
		while( loop < cnt){
			ffield[0].option[loop] = radar_sites[loop][3];
			ffield[0].optionValue[loop] = radar_sites[loop][1];
			loop++;
		}
		var retval = form(ffield,"Radar Site Selector","Select","Cancel");
		if (retval == null  || retval == "")
			if(first_time)
				closeWidget();
			else
				return;
		preferences["WeatherStation"].value = retval;
		savePreferences();
	}
	refresh_map();
	if( first_time){
		RTimer.ticking = true;
		first_time = false;
	}
		
}

//display the weather map

function refresh_map(){

	var mapType="DS.p19r0";
	var url = new URL();
	url.outputFile = system.widgetDataFolder + "/mytempfile.gif";
	var locx = preferences["WeatherStation"].value.toString();
	locx = locx.toLowerCase();
	print(locx);
	if(preferences["mapRange"].value == "Long"){
		if( preferences["mapType"].value == "Composite")
			mapType = "DS.p38cr"
		else
			mapType = "DS.p20-r";
	}else{
		if( preferences["mapType"].value == "Composite")
			mapType = "DS.p37cr"
		else
			mapType = "DS.p19r0";
	}
	url.location = "http://www.erh.noaa.gov/radar/images/" + mapType +"/SI." + locx + 	"/latest.gif";
	print(url.location);
	url.fetch();
	mapimage.src = url.outputFile;
	paint_map();
}

function paint_map()
{
	wmain.height = mapimage.height = preferences["Height"].value;
	wmain.width = mapimage.width = preferences["Width"].value;
	mapimage.reload();	
	
}

function swap_range()
{
	if( preferences["mapRange"].value == "Long")
		preferences["mapRange"].value = "Short";
	else
		preferences["mapRange"].value = "Long";
	savePreferences();
	refresh_map();
}

function grow_image(delta)
{
	var delta_h = Math.round(parseInt(preferences["Height"].value ) * delta / 100);
	var delta_w = Math.round(parseInt( preferences["Width"].value) * delta / 100);
	print( delta_h + " : " + delta_w);
	preferences["Width"].value = (parseInt(preferences["Width"].value) + delta_w).toString(); 
	preferences["Height"].value = (parseInt(preferences["Height"].value) + delta_h).toString();
	savePreferences();
	paint_map();
}

function set_size()
{
	var sizeform = new Array();
	
	sizeform[0] = new FormField();
	sizeform[0].name = "height";
	sizeform[0].type = "text";
	sizeform[0].title = "Height";
	sizeform[0].defaultValue = preferences["Height"].value;
	
	sizeform[1] = new FormField();
	sizeform[1].name = "width";
	sizeform[1].type = "text";
	sizeform[1].title = "Width";
	sizeform[1].defaultValue = preferences["Width"].value;
	
	formResults = form(sizeform, "Set Image Height and Width", "Save", "Cancel");
	
	if( formResults == null)
			return;
	preferences["Height"].value = formResults[0];
	preferences["Width"].value = formResults[1];
	savePreferences();
	paint_map();
}